<id>
Search Subject
</id>

<version>
1.0
</version>

<mod info>
This mod add Search Subject in MessageIndex.

For each Board User/Guests can:
 - Search Subject

Zip Package included
- Search_Subject_Y21.mod
- Search_Subject_Y21_german.mod

Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.
 
Admin/ModList.pl (ASCII)
Languages/English/MessageIndex.lng (ASCII)
Sources/MessageIndex.pl (ASCII)
Templates/default/MessageIndex.template (ASCII)
</mod info>

<author>
Boris Tjuvanov (MF-B) and Jeffrey Man (Jet Li)
</author>

<homepage>
http://yabb.xost.ru/ and http://www.grafix-world.nl
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$search_subject = "Search_Subject|Boris Tjuvanov (<a href=\"http://www.mf-b.ru\" target=\"_blank\">MF-B</a>) and Jeffrey Man (<a href=\"http://www.grafix-world.nl\" target=\"_blank\">Jet Li</a>)|This mod add Search Subject in MessageIndex.|1.0|09/04/06";
	push (@installed_mods, "$search_subject");
</add before>

<edit file>
Languages/English/MessageIndex.lng
</edit file>

<search for>
'842' => "Remove Selected Favorites",
</search for>

<add after>
'844s1' => "Search in Subject",
'844s2' => "Search",
</add after>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
	my $messagecount = ${$uid.$currentboard}{'messagecount'};
</search for>

<add after>
	$ssubjlink = '';
	if ($FORM{'ssubjtext'} ne "" || $INFO{'ssubjtext'} ne "") {
		$search = $FORM{'ssubjtext'} ? $FORM{'ssubjtext'} : $INFO{'ssubjtext'};
		$ssubjlink = qq~;ssubjtext=$search~;
		&FromChars($search);
		if ($search =~ m~/~)  { &fatal_error("no_search_slashes"); }
		if ($search =~ m~\\~) { &fatal_error("no_search_slashes"); }
		$search =~ s/\A\s+//;
		$search =~ s/\s+\Z//;
		&ToHTML($search);
		$search =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
		$search =~ s/\cM//g;
		@search = split(/\s+/, lc $search);

		fopen(BRDTXT, "$boardsdir/$currentboard.txt") || &fatal_error("cannot_open","$boardsdir/$currentboard.txt", 1);
		@threadlisttemp = <BRDTXT>;
		fclose(BRDTXT);
		threadcheck: foreach $threadlisttemp (@threadlisttemp) {
			($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $threadlisttemp);
			foreach (@search) { 
				if ($msub =~ m~(^|\W|_)\Q$_\E(?=$|\W|_)~i) { push(@threadlist, $threadlisttemp); }
			}
		}
		$threadcount = $#threadlist;
	}
</add after>

<search for>
	if ($annboard && $annboard ne $currentboard) {
</search for>

<replace>
	if ($annboard && $annboard ne $currentboard && !$ssubjlink) {
</replace>

<search for>
			if (!$iamguest) { $pagetxtindexst .= qq~<a href="$scripturl?board=$INFO{'board'};start=$start;action=messagepagedrop"><img src="$imagesdir/index_togl.gif" border="0" alt="$messageindex_txt{'19'}" style="vertical-align: middle;" /></a> $messageindex_txt{'139'}: ~; }
</search for>

<replace>
			if (!$iamguest) { $pagetxtindexst .= qq~<a href="$scripturl?board=$INFO{'board'};start=$start;action=messagepagedrop$ssubjlink"><img src="$imagesdir/index_togl.gif" border="0" alt="$messageindex_txt{'19'}" style="vertical-align: middle;" /></a> $messageindex_txt{'139'}: ~; }
</replace>

<search for>
			if ($startpage > 0)          { $pagetxtindex = qq~<a href="$scripturl?board=$currentboard/0" style="font-weight: normal;">1</a>&nbsp;...&nbsp;~; }
			if ($startpage == $maxindex) { $pagetxtindex = qq~<a href="$scripturl?board=$currentboard/0" style="font-weight: normal;">1</a>&nbsp;~; }
</search for>

<replace>
			if ($startpage > 0)          { $pagetxtindex = qq~<a href="$scripturl?board=$currentboard/0$ssubjlink" style="font-weight: normal;">1</a>&nbsp;...&nbsp;~; }
			if ($startpage == $maxindex) { $pagetxtindex = qq~<a href="$scripturl?board=$currentboard/0$ssubjlink" style="font-weight: normal;">1</a>&nbsp;~; }
</replace>

<search for>
				$pagetxtindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?board=$currentboard/$counter" style="font-weight: normal;">$tmpa</a>&nbsp;~;
</search for>

<replace>
				$pagetxtindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?board=$currentboard/$counter$ssubjlink" style="font-weight: normal;">$tmpa</a>&nbsp;~;
</replace>

<search for>
			if ($endpage != $threadcount) { $pageindexadd .= qq~<a href="$scripturl?board=$currentboard/$lastptn" style="font-weight: normal;">$lastpn</a>~; }
</search for>

<replace>
			if ($endpage != $threadcount) { $pageindexadd .= qq~<a href="$scripturl?board=$currentboard/$lastptn$ssubjlink" style="font-weight: normal;">$lastpn</a>~; }
</replace>

<search for>
			$pagedropindex1 .= qq~<span style="float: left; height: 21px; margin: 0; margin-right: 4px;"><a href="$scripturl?board=$INFO{'board'};start=$start;action=messagepagetext"><img src="$imagesdir/index_togl.gif" border="0" alt="$messageindex_txt{'19'}" /></a></span>~;
</search for>

<replace>
			$pagedropindex1 .= qq~<span style="float: left; height: 21px; margin: 0; margin-right: 4px;"><a href="$scripturl?board=$INFO{'board'};start=$start;action=messagepagetext$ssubjlink"><img src="$imagesdir/index_togl.gif" border="0" alt="$messageindex_txt{'19'}" /></a></span>~;
</replace>

<search for>
			else { $pagedropindexpv .= qq~<img src="$imagesdir/index_left.gif" border="0" height="14" width="13" alt="$pidtxt{'02'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?board=$currentboard/$prevpage\\'" ondblclick="location.href=\\'$scripturl?board=$currentboard/0\\'" />~; }
</search for>

<replace>
			else { $pagedropindexpv .= qq~<img src="$imagesdir/index_left.gif" border="0" height="14" width="13" alt="$pidtxt{'02'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?board=$currentboard/$prevpage$ssubjlink\\'" ondblclick="location.href=\\'$scripturl?board=$currentboard/0$ssubjlink\\'" />~; }
</replace>

<search for>
			else { $pagedropindexnx .= qq~<img src="$imagesdir/index_right.gif" height="14" width="13" border="0" alt="$pidtxt{'03'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?board=$currentboard/$nextpage\\'" ondblclick="location.href=\\'$scripturl?board=$currentboard/$lastptn\\'" />~; }
</search for>

<replace>
			else { $pagedropindexnx .= qq~<img src="$imagesdir/index_right.gif" height="14" width="13" border="0" alt="$pidtxt{'03'}" style="display: inline; vertical-align: middle; cursor: pointer;" onclick="location.href=\\'$scripturl?board=$currentboard/$nextpage$ssubjlink\\'" ondblclick="location.href=\\'$scripturl?board=$currentboard/$lastptn$ssubjlink\\'" />~; }
</replace>

<search for>
			else pagedropindex += '<td height="14" class="droppages"><a href="$scripturl?board=$currentboard/' + pagstart + '">' + i + '</a></td>';
</search for>

<replace>
			else pagedropindex += '<td height="14" class="droppages"><a href="$scripturl?board=$currentboard/' + pagstart + '$ssubjlink">' + i + '</a></td>';
</replace>

<search for>
			else pagedropindex += '<td height="14" class="droppages"><a href="$scripturl?board=$currentboard/all-' + allpagstart + '">$pidtxt{"01"}</a></td>';
</search for>

<replace>
			else pagedropindex += '<td height="14" class="droppages"><a href="$scripturl?board=$currentboard/all-' + allpagstart + '$ssubjlink">$pidtxt{"01"}</a></td>';
</replace>

<search for>
	fopen(BRDTXT, "$boardsdir/$currentboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt", 1);
</search for>

<replace>
	if (!$ssubjlink) {
	fopen(BRDTXT, "$boardsdir/$currentboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt", 1);
</replace>

<search for>
	$threadcount = $#threadlist;
</search for>

<replace>
	$threadcount = $#threadlist;
	}
</replace>

<search for>
	$messageindex_template =~ s/<yabb moderators>/$template_mods/g;
</search for>

<add after>
	$ssubjform = qq~
	<form action="$scripturl?board=$currentboard" method="post" name="searchform">
	<td align="right">$messageindex_txt{'844s1'}: <input type="text" size="8" maxlength="$set_subjectMaxLength" name="ssubjtext" value="$search" /> <input type="image" src="$imagesdir/search.gif" style="border: 0; background-color: transparent; vertical-align: middle;" alt="$messageindex_txt{'844s2'}" /></td> 
	</form>
	~;
	$messageindex_template =~ s/<yabb subjsearch>/$ssubjform/g;
</add after>

<edit file>
Templates/default/MessageIndex.template
</edit file>

<search for>
<!-- Board Description and Button Bar end -->

<br />
<div class="seperator">
	<yabb modupdate>
<table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor">
</search for>

<replace>
<!-- Board Description and Button Bar end -->

<br />
<div class="seperator">
<table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor">
</replace>

<search for>
		$messageindex_txt{'70'}
</search for>

<replace>
	<table cellpadding="0" cellspacing="0" border="0" width="100%">
	<tr>
		<td width="10%" align="left">$messageindex_txt{'70'}</td>
		<yabb subjsearch>
	</tr>
	</table>
</replace>

<search for>
		$messageindex_txt{'22'}
	</td>
	<yabb admin column>
</tr>
</search for>

<replace>
		$messageindex_txt{'22'}
	</td>
	<yabb admin column>
</tr>
	<yabb modupdate>
</replace>